/// Autogenerated. Do not modify.
///
/// Profile: 21.60

import 'dart:typed_data';

import '../../base_type.dart';
import '../../data_message.dart';
import '../../definition_message.dart';
import '../../field.dart';
import '../../sub_field.dart';
import '../profile_type.dart';
import '../../errors.dart';
import 'common_fields.dart';

// ignore_for_file: constant_identifier_names

class CadenceZoneMessage extends DataMessage {
  CadenceZoneMessage(
      {definitionMessage,
      developerFields,
      int localId = 0,
      Endian endian = Endian.little})
      : growable = definitionMessage == null,
        super(
            name: CadenceZoneMessage.NAME,
            globalId: CadenceZoneMessage.ID,
            localId: definitionMessage?.localId ?? localId,
            endian: definitionMessage?.endian ?? endian,
            definitionMessage: definitionMessage,
            developerFields: developerFields,
            fields: [
              MessageIndexField(
                  size: definitionMessage
                          ?.getFieldDefinition(MessageIndexField.ID)
                          ?.size ??
                      0,
                  growable: definitionMessage == null),
              CadenceZoneHighValueField(
                  size: definitionMessage
                          ?.getFieldDefinition(CadenceZoneHighValueField.ID)
                          ?.size ??
                      0,
                  growable: definitionMessage == null),
              CadenceZoneNameField(
                  size: definitionMessage
                          ?.getFieldDefinition(CadenceZoneNameField.ID)
                          ?.size ??
                      0,
                  growable: definitionMessage == null)
            ]);

  /// The Global ID of the message. In the FIT documentation this is referred to as the "Global Message Number".
  static const ID = 131;
  static const NAME = 'cadence_zone';

  final bool growable;

  /// Returns an instance of CadenceZoneMessage from a bytes list.
  static CadenceZoneMessage fromBytes(
      DefinitionMessage definitionMessage, Uint8List bytes) {
    final message = CadenceZoneMessage(definitionMessage: definitionMessage);
    message.readFromBytes(bytes);
    return message;
  }

  /// Returns the value of the messageIndex field. Returns null if the field is not defined in the message.
  int? get messageIndex {
    final field = getField(MessageIndexField.ID);
    if (field != null && field.isValid()) {
      var subField = field.getValidSubField(fields);
      return field.getValue(subField: subField);
    } else {
      return null;
    }
  }

  /// Sets the messageIndex field with [value]. Throws [FieldNotDefinedError] if the field is not defined in the message.
  set messageIndex(int? value) {
    final field = getField(MessageIndexField.ID);

    if (field != null) {
      if (value == null) {
        field.clear();
      } else {
        var subField = field.getValidSubField(fields);
        field.setValue(0, value, subField);
      }
    } else {
      throw FieldNotDefinedError(field!.name);
    }
  }

  /// Returns the value of the highValue field. Returns null if the field is not defined in the message.
  int? get highValue {
    final field = getField(CadenceZoneHighValueField.ID);
    if (field != null && field.isValid()) {
      var subField = field.getValidSubField(fields);
      return field.getValue(subField: subField);
    } else {
      return null;
    }
  }

  /// Sets the highValue field with [value]. Throws [FieldNotDefinedError] if the field is not defined in the message.
  set highValue(int? value) {
    final field = getField(CadenceZoneHighValueField.ID);

    if (field != null) {
      if (value == null) {
        field.clear();
      } else {
        var subField = field.getValidSubField(fields);
        field.setValue(0, value, subField);
      }
    } else {
      throw FieldNotDefinedError(field!.name);
    }
  }

  /// Returns the value of the cadenceZoneName field. Returns null if the field is not defined in the message.
  String? get cadenceZoneName {
    final field = getField(CadenceZoneNameField.ID);
    if (field != null && field.isValid()) {
      var subField = field.getValidSubField(fields);
      return field.getValue(subField: subField);
    } else {
      return null;
    }
  }

  /// Sets the cadenceZoneName field with [value]. Throws [FieldNotDefinedError] if the field is not defined in the message.
  set cadenceZoneName(String? value) {
    final field = getField(CadenceZoneNameField.ID);

    if (field != null) {
      if (value == null) {
        field.clear();
      } else {
        var subField = field.getValidSubField(fields);
        field.setValue(0, value, subField);
      }
    } else {
      throw FieldNotDefinedError(field!.name);
    }
  }
}

class CadenceZoneHighValueField extends Field {
  CadenceZoneHighValueField({int size = 0, bool growable = true})
      : super(
            name: 'high_value',
            id: ID,
            type: BaseType.UINT8,
            offset: 0,
            scale: 1,
            size: size,
            units: 'rpm',
            mainTypeName: 'uint8',
            growable: growable,
            subFields: []);

  static const ID = 0;
}

class CadenceZoneNameField extends Field {
  CadenceZoneNameField({int size = 0, bool growable = true})
      : super(
            name: 'name',
            id: ID,
            type: BaseType.STRING,
            offset: 0,
            scale: 1,
            size: size,
            growable: growable,
            subFields: []);

  static const ID = 1;
}
