/// Autogenerated. Do not modify.
///
/// Profile: 21.60

import 'dart:typed_data';

import '../../base_type.dart';
import '../../data_message.dart';
import '../../definition_message.dart';
import '../../field.dart';
import '../../sub_field.dart';
import '../profile_type.dart';
import '../../errors.dart';
import 'common_fields.dart';

// ignore_for_file: constant_identifier_names

class FileCreatorMessage extends DataMessage {
  FileCreatorMessage(
      {definitionMessage,
      developerFields,
      int localId = 0,
      Endian endian = Endian.little})
      : growable = definitionMessage == null,
        super(
            name: FileCreatorMessage.NAME,
            globalId: FileCreatorMessage.ID,
            localId: definitionMessage?.localId ?? localId,
            endian: definitionMessage?.endian ?? endian,
            definitionMessage: definitionMessage,
            developerFields: developerFields,
            fields: [
              FileCreatorSoftwareVersionField(
                  size: definitionMessage
                          ?.getFieldDefinition(
                              FileCreatorSoftwareVersionField.ID)
                          ?.size ??
                      0,
                  growable: definitionMessage == null),
              FileCreatorHardwareVersionField(
                  size: definitionMessage
                          ?.getFieldDefinition(
                              FileCreatorHardwareVersionField.ID)
                          ?.size ??
                      0,
                  growable: definitionMessage == null)
            ]);

  /// The Global ID of the message. In the FIT documentation this is referred to as the "Global Message Number".
  static const ID = 49;
  static const NAME = 'file_creator';

  final bool growable;

  /// Returns an instance of FileCreatorMessage from a bytes list.
  static FileCreatorMessage fromBytes(
      DefinitionMessage definitionMessage, Uint8List bytes) {
    final message = FileCreatorMessage(definitionMessage: definitionMessage);
    message.readFromBytes(bytes);
    return message;
  }

  /// Returns the value of the softwareVersion field. Returns null if the field is not defined in the message.
  int? get softwareVersion {
    final field = getField(FileCreatorSoftwareVersionField.ID);
    if (field != null && field.isValid()) {
      var subField = field.getValidSubField(fields);
      return field.getValue(subField: subField);
    } else {
      return null;
    }
  }

  /// Sets the softwareVersion field with [value]. Throws [FieldNotDefinedError] if the field is not defined in the message.
  set softwareVersion(int? value) {
    final field = getField(FileCreatorSoftwareVersionField.ID);

    if (field != null) {
      if (value == null) {
        field.clear();
      } else {
        var subField = field.getValidSubField(fields);
        field.setValue(0, value, subField);
      }
    } else {
      throw FieldNotDefinedError(field!.name);
    }
  }

  /// Returns the value of the hardwareVersion field. Returns null if the field is not defined in the message.
  int? get hardwareVersion {
    final field = getField(FileCreatorHardwareVersionField.ID);
    if (field != null && field.isValid()) {
      var subField = field.getValidSubField(fields);
      return field.getValue(subField: subField);
    } else {
      return null;
    }
  }

  /// Sets the hardwareVersion field with [value]. Throws [FieldNotDefinedError] if the field is not defined in the message.
  set hardwareVersion(int? value) {
    final field = getField(FileCreatorHardwareVersionField.ID);

    if (field != null) {
      if (value == null) {
        field.clear();
      } else {
        var subField = field.getValidSubField(fields);
        field.setValue(0, value, subField);
      }
    } else {
      throw FieldNotDefinedError(field!.name);
    }
  }
}

class FileCreatorSoftwareVersionField extends Field {
  FileCreatorSoftwareVersionField({int size = 0, bool growable = true})
      : super(
            name: 'software_version',
            id: ID,
            type: BaseType.UINT16,
            offset: 0,
            scale: 1,
            size: size,
            growable: growable,
            subFields: []);

  static const ID = 0;
}

class FileCreatorHardwareVersionField extends Field {
  FileCreatorHardwareVersionField({int size = 0, bool growable = true})
      : super(
            name: 'hardware_version',
            id: ID,
            type: BaseType.UINT8,
            offset: 0,
            scale: 1,
            size: size,
            growable: growable,
            subFields: []);

  static const ID = 1;
}
